/*
 * ar_valdisplay.c
 *
 *  Created on: 
 *      Author: 
 */
/***********************************
 * To display values with ranges on the screen
 **************************************/
#include <stdio.h>
#include "EV600A_common.h"
#include "EV600A_valdisplay.h"


void lv_set_vdname(lv_obj_t *lbl, ar_vent_val_type vtype)
{
	switch(vtype)
	{
		case AR_VENT_PEEP:
		    lv_label_set_text(lbl, "TEMP");
		    break;
		case AR_VENT_RRATE:
			lv_label_set_text(lbl, "HUMIDITY");
		    break;
		case AR_VENT_MINVOL:
			lv_label_set_text(lbl, "SPO2");
		    break;
		case AR_VENT_FIO2:
			lv_label_set_text(lbl, "BPM");
		    break;
//		case AR_VENT_PPEAK:
//			lv_label_set_text(lbl, "");
//		    break;
	}
}

void lv_set_vdunits(lv_obj_t *lbl, ar_vent_val_type vtype)
{
	switch(vtype)
	{
		case AR_VENT_PEEP:
		    lv_label_set_text(lbl, "");
		    break;
		case AR_VENT_RRATE:
			lv_label_set_text(lbl, "");
		    break;
		case AR_VENT_MINVOL:
			lv_label_set_text(lbl, "");
		    break;
		case AR_VENT_FIO2:
			lv_label_set_text(lbl, "");
//		    break;
//		case AR_VENT_PPEAK:
//			lv_label_set_text(lbl, "");
//		    break;
	}
}

void lv_set_valdisplay_pos(lv_valdisplay *vdisp, uint16_t xpos, uint16_t ypos)
{
	lv_obj_set_pos(vdisp->vdcont, xpos, ypos);
}


void lv_create_valdisplay(lv_valdisplay *cvaldsply, ar_vent_val_type vtype)
{
	cvaldsply->vdcont = lv_cont_create(lv_scr_act(), NULL);
    lv_obj_set_pos(cvaldsply->vdcont, 20, 40);
    lv_obj_set_size(cvaldsply->vdcont, 205, 80);
    lv_obj_set_style_local_border_width(cvaldsply->vdcont, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT,0);
    lv_obj_set_style_local_border_color(cvaldsply->vdcont, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_MONITOR_RECTANGLE_OUTLINE);
    lv_obj_set_style_local_bg_color(cvaldsply->vdcont, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_MONITOR_RECTANGLE);

    cvaldsply->vdname = lv_label_create(cvaldsply->vdcont, NULL);
    lv_set_vdname(cvaldsply->vdname, vtype);
    lv_obj_set_style_local_text_font(cvaldsply->vdname, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, &lv_font_montserrat_12);
    lv_obj_set_style_local_text_color(cvaldsply->vdname, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);
    lv_obj_set_pos(cvaldsply->vdname, 10, 10 );

    cvaldsply->vdvalue = lv_label_create(cvaldsply->vdcont, NULL);
    lv_label_set_text(cvaldsply->vdvalue, "20");
    lv_obj_set_style_local_text_font(cvaldsply->vdvalue, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, &lv_font_montserrat_46);
    lv_obj_set_style_local_text_color(cvaldsply->vdvalue, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);
    lv_obj_set_pos(cvaldsply->vdvalue, 90, 20 );

    cvaldsply->vdunits = lv_label_create(cvaldsply->vdcont, NULL);
    lv_set_vdunits(cvaldsply->vdunits, vtype);
    lv_obj_set_style_local_text_font(cvaldsply->vdunits, LV_LABEL_PART_MAIN, LV_STATE_DEFAULT, &lv_font_montserrat_12);
    lv_obj_set_style_local_text_color(cvaldsply->vdunits, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);
    lv_obj_set_pos(cvaldsply->vdunits, 80, 80 );
}
