#include <stdio.h>
#include "EV600A_common.h"
#include "EV600A_ventalarms.h"
#include "EV600A_ventilator.h"
#include "EV600A_ventask.h"

static lv_group_t*  alarmGrp;

void ARIES_show_alarms_Window(void)
{
    lv_obj_set_hidden(win, false);
}

extern void ARIES_applybuttonstyles(lv_obj_t *btn);

static void fio2_slider_event_cb(lv_obj_t * slider, lv_event_t event)
{
	if(event == LV_EVENT_VALUE_CHANGED) {
        static char buf[4]; /* max 3 bytes for number plus 1 null terminating byte */
        snprintf(buf, 4, "%u", lv_slider_get_value(slider));
        lv_label_set_text(fio2maxlbl, buf);
        lv_label_set_text(FIO2_upper_limit,buf);
    }
}

static void fio2_slider_low_event_cb(lv_obj_t * slider, lv_event_t event)
{
	if(event == LV_EVENT_VALUE_CHANGED) {
        static char buf[4]; /* max 3 bytes for number plus 1 null terminating byte */
        snprintf(buf, 4, "%u", lv_slider_get_value(slider));
        lv_label_set_text(fio2minlbl, buf);
        lv_label_set_text(FIO2_low_limit,buf);
    }
}

static void vt_slider_event_cb(lv_obj_t * slider, lv_event_t event)
{
	if(event == LV_EVENT_VALUE_CHANGED) {
        static char buf[5]; /* max 3 bytes for number plus 1 null terminating byte */
        snprintf(buf, 5, "%u", lv_slider_get_value(slider));
        lv_label_set_text(vtmaxlbl, buf);
        lv_label_set_text(TV_upper_limit,buf);
    }
}

static void vt_slider_low_event_cb(lv_obj_t * slider, lv_event_t event)
{
	if(event == LV_EVENT_VALUE_CHANGED) {
        static char buf[5]; /* max 3 bytes for number plus 1 null terminating byte */
        snprintf(buf, 5, "%u", lv_slider_get_value(slider));
        lv_label_set_text(vtminlbl, buf);
        lv_label_set_text(TV_low_limit,buf);
    }
}

static void mv_slider_event_cb(lv_obj_t * slider, lv_event_t event)
{
	if(event == LV_EVENT_VALUE_CHANGED) {
        static char buf[5]; // max 3 bytes for number plus 1 null terminating byte
        snprintf(buf, 5, "%u", lv_slider_get_value(slider));
        lv_label_set_text(mvmaxlbl, buf);
        lv_label_set_text(MV_upper_limit,buf);
    }
}

static void mv_slider_low_event_cb(lv_obj_t * slider, lv_event_t event)
{
	if(event == LV_EVENT_VALUE_CHANGED) {
        static char buf[5]; // max 3 bytes for number plus 1 null terminating byte
        snprintf(buf, 5, "%u", lv_slider_get_value(slider));
        lv_label_set_text(mvminlbl, buf);
        lv_label_set_text(MV_low_limit,buf);
    }
}


static void pip_slider_event_cb(lv_obj_t * slider, lv_event_t event)
{
	if(event == LV_EVENT_VALUE_CHANGED) {
        static char buf[4]; /* max 3 bytes for number plus 1 null terminating byte */
            snprintf(buf, 4, "%u", lv_slider_get_value(slider));
            lv_label_set_text(pipmaxlbl, buf);
            lv_label_set_text(PIP_upper_limit,buf);
    }
}

static void pip_slider_low_event_cb(lv_obj_t * slider, lv_event_t event)
{
	if(event == LV_EVENT_VALUE_CHANGED) {
        static char buf[4]; /* max 3 bytes for number plus 1 null terminating byte */

            snprintf(buf, 4, "%u", lv_slider_get_value(slider));
            lv_label_set_text(pipminlbl, buf);
            lv_label_set_text(PIP_low_limit,buf);
    }
}

static void alarm_close_event_cb(lv_obj_t * obj, lv_event_t event)
{
    if(event == LV_EVENT_CLICKED) {
    	lv_obj_set_hidden(win, true);
    	u8_alarm_close_toch_selection = 1;
    }
}

lv_obj_t * lv_create_ventalarms()
{
    /*Create a window*/
    win = lv_cont_create(lv_scr_act(), NULL);
    lv_obj_set_pos(win, 100, 50 );
    lv_obj_set_size(win, 700, 450);
    lv_obj_set_style_local_bg_color(win, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT,ARIES_HF_BLUE);

    /*Create a fio2 slider*/
    lv_obj_t *header = lv_label_create(win, NULL);
    lv_obj_set_pos(header, 100, 10 );
	lv_label_set_text(header,"EV600A  Set Alarm Values:");

    /*Create a fio2 slider*/
    lv_obj_t *fio2lbl = lv_label_create(win, NULL);
    lv_obj_set_pos(fio2lbl, 50, 50 );
	lv_label_set_text(fio2lbl,"FiO2:");
	lv_obj_set_style_local_text_color(win, LV_LABEL_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);

    fio2slider = lv_slider_create(win, NULL);
    lv_slider_set_type(fio2slider, LV_SLIDER_TYPE_NORMAL);
    lv_slider_set_range(fio2slider, 18, 105);
    lv_obj_set_event_cb(fio2slider, fio2_slider_event_cb);
    lv_obj_set_pos(fio2slider, 50, 80 );
	 lv_obj_set_style_local_border_width(fio2slider, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT,2);
	 lv_obj_set_style_local_border_width(fio2slider, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, 2);
    fio2slider_low = lv_slider_create(win, NULL);
    lv_slider_set_type(fio2slider_low, LV_SLIDER_TYPE_NORMAL);
    lv_slider_set_range(fio2slider_low, 18, 105);
    lv_obj_set_event_cb(fio2slider_low, fio2_slider_low_event_cb);
    lv_obj_set_pos(fio2slider_low, 400, 80 );
	 lv_obj_set_style_local_border_width(fio2slider_low, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT,2);
	 lv_obj_set_style_local_border_width(fio2slider_low, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, 2);
    fio2minlbl = lv_label_create(win, NULL);
    lv_obj_set_pos(fio2minlbl, 400, 100 );
	lv_label_set_text(fio2minlbl,"18");
	fio2maxlbl = lv_label_create(win, NULL);
    lv_obj_set_pos(fio2maxlbl, 280, 100 );
	lv_label_set_text(fio2maxlbl,"105");
	lv_slider_set_value(fio2slider_low, 18, LV_ANIM_ON);
	lv_slider_set_value(fio2slider, 105, LV_ANIM_ON);
    lv_obj_set_style_local_bg_color(fio2slider, LV_SLIDER_PART_BG, LV_STATE_DEFAULT, ARIES_HF_BTN_BLUE);
    lv_obj_set_style_local_bg_color(fio2slider_low, LV_SLIDER_PART_BG, LV_STATE_DEFAULT, ARIES_HF_BTN_BLUE);

    /*Create a vt slider*/
    lv_obj_t *vtlbl = lv_label_create(win, NULL);
    lv_obj_set_pos(vtlbl, 50, 130 );
	lv_label_set_text(vtlbl,"Vt:");
	lv_obj_set_style_local_text_color(win, LV_LABEL_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);
    vtslider = lv_slider_create(win, NULL);
    lv_slider_set_type(vtslider, LV_SLIDER_TYPE_NORMAL);
    lv_slider_set_range(vtslider, 100, 2000);
    lv_obj_set_event_cb(vtslider, vt_slider_event_cb);
    lv_obj_set_pos(vtslider, 50, 160 );
	 lv_obj_set_style_local_border_width(vtslider, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT,2);
	 lv_obj_set_style_local_border_width(vtslider, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, 2);
    vtslider_low = lv_slider_create(win, NULL);
    lv_slider_set_type(vtslider_low, LV_SLIDER_TYPE_NORMAL);
    lv_slider_set_range(vtslider_low, 100, 2000);
    lv_obj_set_event_cb(vtslider_low, vt_slider_low_event_cb);
    lv_obj_set_pos(vtslider_low, 400, 160 );
	 lv_obj_set_style_local_border_width(vtslider_low, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT,2);
	 lv_obj_set_style_local_border_width(vtslider_low, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, 2);
    vtminlbl = lv_label_create(win, NULL);
    lv_obj_set_pos(vtminlbl, 400, 180 );
	lv_label_set_text(vtminlbl,"600");
	vtmaxlbl = lv_label_create(win, NULL);
    lv_obj_set_pos(vtmaxlbl, 280, 180 );
	lv_label_set_text(vtmaxlbl,"1800");
	lv_slider_set_left_value(vtslider_low, 100, LV_ANIM_ON);
	lv_slider_set_value(vtslider, 100, LV_ANIM_ON);
    lv_obj_set_style_local_bg_color(vtslider, LV_SLIDER_PART_BG, LV_STATE_DEFAULT, ARIES_HF_BTN_BLUE);
    lv_obj_set_style_local_bg_color(vtslider_low, LV_SLIDER_PART_BG, LV_STATE_DEFAULT, ARIES_HF_BTN_BLUE);

    /*Create a mv slider*/
    lv_obj_t *mvlbl = lv_label_create(win, NULL);
    lv_obj_set_pos(mvlbl, 50, 210 );
	lv_label_set_text(mvlbl,"MV:");
	lv_obj_set_style_local_text_color(win, LV_LABEL_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);
    mvslider = lv_slider_create(win, NULL);
    lv_slider_set_type(mvslider, LV_SLIDER_TYPE_NORMAL);
    lv_slider_set_range(mvslider, 4, 120);
    lv_obj_set_event_cb(mvslider, mv_slider_event_cb);
    lv_obj_set_pos(mvslider, 50, 240 );
	 lv_obj_set_style_local_border_width(mvslider, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT,2);
	 lv_obj_set_style_local_border_width(mvslider, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, 2);
    mvslider_low = lv_slider_create(win, NULL);
    lv_slider_set_type(mvslider_low, LV_SLIDER_TYPE_NORMAL);
    lv_slider_set_range(mvslider_low, 4, 120);
    lv_obj_set_event_cb(mvslider_low, mv_slider_low_event_cb);
    lv_obj_set_pos(mvslider_low, 400, 240 );
	 lv_obj_set_style_local_border_width(mvslider_low, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT,2);
	 lv_obj_set_style_local_border_width(mvslider_low, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, 2);
    mvminlbl = lv_label_create(win, NULL);
    lv_obj_set_pos(mvminlbl, 400, 260 );
	lv_label_set_text(mvminlbl,"12");
	mvmaxlbl = lv_label_create(win, NULL);
    lv_obj_set_pos(mvmaxlbl, 280, 260 );
	lv_label_set_text(mvmaxlbl,"40");
	lv_slider_set_value(mvslider_low, 40, LV_ANIM_ON);
    lv_obj_set_style_local_bg_color(mvslider, LV_SLIDER_PART_BG, LV_STATE_DEFAULT, ARIES_HF_BTN_BLUE);
    lv_obj_set_style_local_bg_color(mvslider_low, LV_SLIDER_PART_BG, LV_STATE_DEFAULT, ARIES_HF_BTN_BLUE);

    /*Create a peep slider*/
    lv_obj_t *piplbl = lv_label_create(win, NULL);
    lv_obj_set_pos(piplbl, 50, 290 );
	lv_label_set_text(piplbl,"PIP:");
	lv_obj_set_style_local_text_color(win, LV_LABEL_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);
    pipslider = lv_slider_create(win, NULL);
    lv_slider_set_type(pipslider, LV_SLIDER_TYPE_NORMAL);
    lv_slider_set_range(pipslider, 0, 100);
    lv_obj_set_event_cb(pipslider, pip_slider_event_cb);
    lv_obj_set_pos(pipslider, 50, 320 );
	 lv_obj_set_style_local_border_width(pipslider, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT,2);
	 lv_obj_set_style_local_border_width(pipslider, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, 2);
    pipslider_low = lv_slider_create(win, NULL);
    lv_slider_set_type(pipslider_low, LV_SLIDER_TYPE_NORMAL);
    lv_slider_set_range(pipslider_low, 0, 100);
    lv_obj_set_event_cb(pipslider_low, pip_slider_low_event_cb);
    lv_obj_set_pos(pipslider_low, 400, 320 );
    pipminlbl = lv_label_create(win, NULL);
    lv_obj_set_pos(pipminlbl, 400, 340 );
	lv_label_set_text(pipminlbl,"40");
	pipmaxlbl = lv_label_create(win, NULL);
    lv_obj_set_pos(pipmaxlbl, 280, 340 );
	 lv_obj_set_style_local_border_width(pipslider_low, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT,2);
	 lv_obj_set_style_local_border_width(pipslider_low, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, 2);
	lv_label_set_text(pipmaxlbl,"100");
	lv_slider_set_left_value(pipslider_low, 0, LV_ANIM_ON);
	lv_slider_set_value(pipslider_low, 0, LV_ANIM_ON);
    lv_obj_set_style_local_bg_color(pipslider, LV_SLIDER_PART_BG, LV_STATE_DEFAULT, ARIES_HF_BTN_BLUE);
    lv_obj_set_style_local_bg_color(pipslider_low, LV_SLIDER_PART_BG, LV_STATE_DEFAULT, ARIES_HF_BTN_BLUE);

    //upper limit
    TV_upper_limit = lv_label_create(lv_scr_act(), NULL);
    lv_obj_set_pos(TV_upper_limit, 850, 95);
    lv_label_set_text_fmt(TV_upper_limit,"%d",1600);
    lv_obj_set_style_local_text_font(TV_upper_limit, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, &lv_font_montserrat_14);
    lv_obj_set_style_local_text_color(TV_upper_limit, LV_LABEL_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);

    PIP_upper_limit = lv_label_create(lv_scr_act(), NULL);
    lv_obj_set_pos(PIP_upper_limit, 850, 200);
    lv_label_set_text_fmt(PIP_upper_limit,"%d",45);
    lv_obj_set_style_local_text_font(PIP_upper_limit, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, &lv_font_montserrat_14);
    lv_obj_set_style_local_text_color(PIP_upper_limit, LV_LABEL_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);

    MV_upper_limit = lv_label_create(lv_scr_act(), NULL);
    lv_obj_set_pos(MV_upper_limit, 850, 285);
    lv_label_set_text_fmt(MV_upper_limit,"%d",34);
    lv_obj_set_style_local_text_font(MV_upper_limit, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, &lv_font_montserrat_14);
    lv_obj_set_style_local_text_color(MV_upper_limit, LV_LABEL_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);

    FIO2_upper_limit = lv_label_create(lv_scr_act(), NULL);
    lv_obj_set_pos(FIO2_upper_limit, 850, 370);
    lv_label_set_text_fmt(FIO2_upper_limit,"%d",105);
    lv_obj_set_style_local_text_font(FIO2_upper_limit, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, &lv_font_montserrat_14);
    lv_obj_set_style_local_text_color(FIO2_upper_limit, LV_LABEL_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);

    //lower limit
	TV_low_limit = lv_label_create(lv_scr_act(), NULL);
    lv_obj_set_pos(TV_low_limit, 850, 115);
    lv_label_set_text_fmt(TV_low_limit,"%d",600);
	lv_obj_set_style_local_text_font(TV_low_limit, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, &lv_font_montserrat_14);
	lv_obj_set_style_local_text_color(TV_low_limit, LV_LABEL_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);

	PIP_low_limit = lv_label_create(lv_scr_act(), NULL);
    lv_obj_set_pos(PIP_low_limit, 850, 180);
    lv_label_set_text_fmt(PIP_low_limit,"%d",35);
	lv_obj_set_style_local_text_font(PIP_low_limit, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, &lv_font_montserrat_14);
	lv_obj_set_style_local_text_color(PIP_low_limit, LV_LABEL_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);

	MV_low_limit = lv_label_create(lv_scr_act(), NULL);
    lv_obj_set_pos(MV_low_limit, 850, 265);
    lv_label_set_text_fmt(MV_low_limit,"%d",12);
	lv_obj_set_style_local_text_font(MV_low_limit, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, &lv_font_montserrat_14);
	lv_obj_set_style_local_text_color(MV_low_limit, LV_LABEL_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);

	FIO2_low_limit = lv_label_create(lv_scr_act(), NULL);
    lv_obj_set_pos(FIO2_low_limit, 850, 350);
    lv_label_set_text_fmt(FIO2_low_limit,"%d",18);
	lv_obj_set_style_local_text_font(FIO2_low_limit, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, &lv_font_montserrat_14);
	lv_obj_set_style_local_text_color(FIO2_low_limit, LV_LABEL_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);

	//btn
	alarmCloseBtn = lv_btn_create(win, NULL);
    lv_obj_set_pos(alarmCloseBtn, 200, 380 );
    lv_obj_set_size(alarmCloseBtn, 100, 50);
    lv_obj_set_style_local_value_str(alarmCloseBtn, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_SYMBOL_HOME "Back");
    ARIES_applybuttonstyles(alarmCloseBtn);
    lv_obj_set_event_cb(alarmCloseBtn, alarm_close_event_cb);
	 lv_obj_set_style_local_border_width(alarmCloseBtn, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT,4);
	 lv_obj_set_style_local_border_width(alarmCloseBtn, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED,4);

	lv_obj_set_hidden(win, true);
	return win;
}

