/*
 * ar_ventmodel.c
 *
 *  Created on:
 *      Author:
 */
#include <stdint.h>
#include "../../../lvgl/lvgl.h"
#include "EV600A_ventask.h"
#include "EV600A_ventilator.h"
#include "EV600A_ventalarms.h"
#include "main.h"
#include "touchpad.h"
#include "GUI_Paint.h"
#include "math.h"
#include "tim.h"

AR_VentModel vModel;
AR_VentModel vModelBase;
bool tv_event_toggle=0,rr_event_toggle=0,ie_event_toggle=0,p_limit_event_toggle=0,peep_event_toggle=0,trigger_event_toggle=0,mode_event_toogle=0;
uint8_t selection_toggle_flag = 1 , select_alarm_limit_toggle_flag=1, alarm_selection_toggle_flag=1,u8_menu_toggle_flag=1;
uint8_t u8_fio2_once_occur_flag = 1, u8_fio2_selection_toggle_flag=1, u8_fio2_select_icon_flag=1,u8_fio2_calib_selection_flag=0;
uint8_t u8_once_occur_event_handler=1;
uint8_t u8_once_occur_bpm = 0, u8_once_occur_temp = 0, u8_once_occur_humidity = 0, u8_once_occur_spo2 = 0, u8_once_occur_sw1 = 0, u8_once_occur_sw2 = 0;

uint8_t u8_select_bpm = 0, u8_select_temp = 0, u8_select_humidity = 0, u8_select_spo2 = 0, u8_select_sw1 = 0, u8_select_sw2 = 0;

uint16_t task_0 ,task_1 , task_2 ;

uint16_t enc_value ;

uint8_t u8_once_select_tv = 0, u8_once_select_rr = 0, u8_once_select_ie = 0, u8_once_select_gas = 0, u8_once_select_fio2 = 0;

enum E_encoder_select_sw
{
	select_icons=1,main_screen_selection=2,alarm_screen_selection=3
};
enum E_encoder_select_sw encoder_select_sw = select_icons;

void BPM_selected(){
 lv_obj_set_style_local_border_color(BPM_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);
 lv_obj_set_style_local_border_color(BPM_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, LV_COLOR_WHITE);
 lv_obj_set_style_local_border_color(TEMP_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(TEMP_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(HUMIDITY_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(HUMIDITY_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(SPO2_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(SPO2_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(SW1_sw, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, ARIES_HF_BTN_BLUE);
 lv_obj_set_style_local_border_color(SW1_sw, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, ARIES_HF_BTN_BLUE);
 lv_obj_set_style_local_border_color(SW1_sw, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, ARIES_HF_BTN_BLUE);
 lv_obj_set_style_local_border_color(SW1_sw, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, ARIES_HF_BTN_BLUE);
}

void TEMP_selected(){
 lv_obj_set_style_local_border_color(BPM_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(BPM_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(TEMP_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);
 lv_obj_set_style_local_border_color(TEMP_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, LV_COLOR_WHITE);
 lv_obj_set_style_local_border_color(HUMIDITY_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(HUMIDITY_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(SPO2_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(SPO2_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(SW1_sw, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, ARIES_HF_BTN_BLUE);
 lv_obj_set_style_local_border_color(SW1_sw, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, ARIES_HF_BTN_BLUE);
 lv_obj_set_style_local_border_color(SW2_sw, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, ARIES_HF_BTN_BLUE);
 lv_obj_set_style_local_border_color(SW2_sw, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, ARIES_HF_BTN_BLUE);
}
void HUMIDITY_selected(){
 lv_obj_set_style_local_border_color(BPM_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(BPM_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(TEMP_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(TEMP_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(HUMIDITY_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);
 lv_obj_set_style_local_border_color(HUMIDITY_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, LV_COLOR_WHITE);
 lv_obj_set_style_local_border_color(SPO2_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(SPO2_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(SW1_sw, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, ARIES_HF_BTN_BLUE);
 lv_obj_set_style_local_border_color(SW1_sw, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, ARIES_HF_BTN_BLUE);
 lv_obj_set_style_local_border_color(SW2_sw, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, ARIES_HF_BTN_BLUE);
 lv_obj_set_style_local_border_color(SW2_sw, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, ARIES_HF_BTN_BLUE);
}

void bpm_selected()
{
	 lv_obj_set_style_local_border_color(BPM_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_MONITOR_RECTANGLE_OUTLINE);
	 lv_obj_set_style_local_border_color(BPM_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_MONITOR_RECTANGLE_OUTLINE);
	 lv_obj_set_style_local_border_color(TEMP_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_MONITOR_RECTANGLE_OUTLINE);
	 lv_obj_set_style_local_border_color(TEMP_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_MONITOR_RECTANGLE_OUTLINE);
	 lv_obj_set_style_local_border_color(HUMIDITY_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_MONITOR_RECTANGLE_OUTLINE);
	 lv_obj_set_style_local_border_color(HUMIDITY_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_MONITOR_RECTANGLE_OUTLINE);
	 lv_obj_set_style_local_border_color(SPO2_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);
	 lv_obj_set_style_local_border_color(SPO2_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, LV_COLOR_WHITE);
	 lv_obj_set_style_local_border_color(SW1_sw, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, ARIES_HF_BTN_BLUE);
	 lv_obj_set_style_local_border_color(SW1_sw, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, ARIES_HF_BTN_BLUE);
	 lv_obj_set_style_local_border_color(SW2_sw, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, ARIES_HF_BTN_BLUE);
	 lv_obj_set_style_local_border_color(SW2_sw, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, ARIES_HF_BTN_BLUE);
}

void SW1_selected(){

 lv_obj_set_style_local_border_color(BPM_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(BPM_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(TEMP_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(TEMP_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(HUMIDITY_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT,EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(HUMIDITY_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(SPO2_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(SPO2_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(SW1_sw, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, ARIES_HF_BTN_BLUE);
 lv_obj_set_style_local_border_color(SW1_sw, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, ARIES_HF_BTN_BLUE);
 lv_obj_set_style_local_border_color(SW2_sw, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);
 lv_obj_set_style_local_border_color(SW2_sw, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, LV_COLOR_WHITE);
}

void SW2_selected(){

 lv_obj_set_style_local_border_color(BPM_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(BPM_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(TEMP_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(TEMP_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(HUMIDITY_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT,EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(HUMIDITY_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(SPO2_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(SPO2_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_MONITOR_RECTANGLE_OUTLINE);
 lv_obj_set_style_local_border_color(SW1_sw, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);
 lv_obj_set_style_local_border_color(SW1_sw, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, LV_COLOR_WHITE);
 lv_obj_set_style_local_border_color(SW2_sw, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, ARIES_HF_BTN_BLUE);
 lv_obj_set_style_local_border_color(SW2_sw, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, ARIES_HF_BTN_BLUE);
}

void BPM_change_fun(){
	if(u8_select_bpm == 0)
	{
		lv_obj_set_style_local_border_color(BPM_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_select_set_parameter);
		lv_obj_set_style_local_border_color(BPM_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_select_set_parameter);
		u8_select_bpm = 1, u8_select_temp = 0, u8_select_humidity = 0, u8_select_spo2 = 0, u8_select_sw1 = 0, u8_select_sw2 = 0;
	}

if ( u8_previous_data == 1 ) {
	 u8_previous_data = 0 ;
	 TIM2->CNT =( (u16_BPM_data ) / 10) ;
}
if(TIM2->CNT > 64000  ){
		TIM2->CNT = 0 ;
	}
if(TIM2->CNT >= 160 ){
	TIM2->CNT = 160;
}
else if(TIM2->CNT <= 10  ){
	TIM2->CNT = 10;
}
u16_BPM_data = ((TIM2->CNT ) * 10) ;

if((u16_BPM_data >= 0) && (u16_BPM_data < 10))
	lv_obj_set_pos(BPM_monitor_data, 60, 525);
else if((u16_BPM_data >= 10) && (u16_BPM_data < 100))
	lv_obj_set_pos(BPM_monitor_data, 55, 525);
else if((u16_BPM_data >= 100) && (u16_BPM_data < 1000))
	lv_obj_set_pos(BPM_monitor_data, 45, 525);
else if((u16_BPM_data >= 1000) && (u16_BPM_data < 10000))
	lv_obj_set_pos(BPM_monitor_data, 35, 525);

lv_label_set_text_fmt(BPM_monitor_data,"%d",u16_BPM_data);
}

void TEMP_change_fun(){
	if(u8_select_temp == 0)
	{
     lv_obj_set_style_local_border_color(TEMP_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_select_set_parameter);
    lv_obj_set_style_local_border_color(TEMP_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_select_set_parameter);
    u8_select_bpm = 0, u8_select_temp = 1, u8_select_humidity = 0, u8_select_spo2 = 0, u8_select_sw1 = 0, u8_select_sw2 = 0;
	}

	 if ( u8_previous_data == 1 ) {
		 u8_previous_data = 0 ;
		 TIM2->CNT = u8_TEMP_data  ;
	 }
	 if(TIM2->CNT > 64000  ){
	 		TIM2->CNT = 0 ;
	 	}
	if(TIM2->CNT >= 100){
		TIM2->CNT = 100;
	}
	else if(TIM2->CNT <=   1){
		TIM2->CNT =1;
	}
	u8_TEMP_data = TIM2->CNT  ;

	if((u8_TEMP_data >= 0) && (u8_TEMP_data < 10))
		lv_obj_set_pos(TEMP_monitor_data, 210, 525);
	else if((u8_TEMP_data >= 10) && (u8_TEMP_data < 100))
		lv_obj_set_pos(TEMP_monitor_data, 200, 525);
	else if((u8_TEMP_data >= 100) && (u8_TEMP_data < 1000))
		lv_obj_set_pos(TEMP_monitor_data, 185, 525);

	lv_label_set_text_fmt(TEMP_monitor_data,"%d",u8_TEMP_data);
}
void HUMIDITY_change_fun(){
	if(u8_select_humidity == 0)
	{
     lv_obj_set_style_local_border_color(HUMIDITY_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_select_set_parameter);
     lv_obj_set_style_local_border_color(HUMIDITY_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_select_set_parameter);
     u8_select_bpm = 0, u8_select_temp = 0, u8_select_humidity = 1, u8_select_spo2 = 0, u8_select_sw1 = 0, u8_select_sw2 = 0;
	}


	 if ( u8_previous_data == 1 ) {
		 u8_previous_data = 0 ;
		 TIM2->CNT = u8_ie_data  ;
	 }
	 if(TIM2->CNT > 64000  ){
	 		TIM2->CNT = 0 ;
	 	}
	if(TIM2->CNT >= 150 ){
		TIM2->CNT = 150;
	}
	else if(TIM2->CNT <= 20  ){
		TIM2->CNT = 20;
	}
	u8_ie_data = TIM2->CNT  ;

	lv_label_set_text_fmt(HUMIDITY_monitor_data,"%d",u8_ie_data);
}

void SPO2_change_fun()
{
	if(u8_select_spo2 == 0)
	{
    lv_obj_set_style_local_border_color(SPO2_set, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_select_set_parameter);
    lv_obj_set_style_local_border_color(SPO2_set, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_select_set_parameter);
	u8_select_bpm = 0, u8_select_temp = 0, u8_select_humidity = 0, u8_select_spo2 = 1, u8_select_sw1 = 0, u8_select_sw2 = 0;
	}

	 if ( u8_previous_data == 1 ) {
		 u8_previous_data = 0 ;
		 TIM2->CNT = u8_pip_data  ;
	 }
	 if(TIM2->CNT > 64000  ){
	 		TIM2->CNT = 0 ;
	 	}
	if(TIM2->CNT >= 120 ){
		TIM2->CNT = 120;
	}
	else if(TIM2->CNT <= 20 ){
		TIM2->CNT = 20;
	}
	u8_pip_data = TIM2->CNT  ;

	lv_label_set_text_fmt(SPO2_monitor_data,"%d",u8_pip_data);
}

void gas_change_fun(){
	if(u8_select_sw1 == 0)
	{
	lv_obj_set_style_local_border_color(SW2_sw, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_select_set_parameter);
	lv_obj_set_style_local_border_color(SW2_sw, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_select_set_parameter);
	u8_select_bpm = 0, u8_select_temp = 0, u8_select_humidity = 0, u8_select_spo2 = 0, u8_select_sw1 = 1, u8_select_sw2 = 0;
	}

 if ( u8_previous_data == 1 ) {
	 u8_previous_data = 0 ;
	gas_sw_toggle = !gas_sw_toggle;
 }

	if(gas_sw_toggle == 1){
		  lv_switch_on(SW2_sw, LV_ANIM_OFF);
	}
	else if(gas_sw_toggle == 0){
		   lv_switch_off(SW2_sw, LV_ANIM_OFF);
	}
}

void fio2_change_fun(){
	if(u8_select_sw2 == 0)
	{
		lv_obj_set_style_local_border_color(SW1_sw, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, EV600A_select_set_parameter);
		lv_obj_set_style_local_border_color(SW1_sw, LV_OBJ_PART_MAIN, LV_STATE_FOCUSED, EV600A_select_set_parameter);
		u8_select_bpm = 0, u8_select_temp = 0, u8_select_humidity = 0, u8_select_spo2 = 0, u8_select_sw1 = 0, u8_select_sw2 = 1;
	}
 if ( u8_previous_data == 1 ) {
	 u8_previous_data = 0 ;
	fio2_sw_toogle = !fio2_sw_toogle;
 }

	if(fio2_sw_toogle == 1){
		   lv_switch_on(SW1_sw, LV_ANIM_OFF);
	}
	else if(fio2_sw_toogle == 0){
		   lv_switch_off(SW1_sw, LV_ANIM_OFF);
	}
}

static void BPM_event_handler(lv_obj_t *btn,lv_event_t event){
	if(event == LV_EVENT_FOCUSED){
		tv_event_toggle = 1;
	}
	else if(event == LV_EVENT_DEFOCUSED){
		tv_event_toggle = 0;
	}
	if(event == LV_EVENT_PRESSED){
		selection_toggle_flag = 1;
	}
}

static void TEMP_event_handler(lv_obj_t *btn,lv_event_t event){
	if(event == LV_EVENT_FOCUSED){
		rr_event_toggle = 1;
	}
	else if(event == LV_EVENT_DEFOCUSED){
		rr_event_toggle = 0;
	}
	if(event == LV_EVENT_PRESSED){
		selection_toggle_flag = 1;
	}
}

static void HUMIDITY_event_handler(lv_obj_t *btn,lv_event_t event){
	if(event == LV_EVENT_FOCUSED){
		ie_event_toggle = 1;
	}
	else if(event == LV_EVENT_DEFOCUSED){
		ie_event_toggle = 0;
	}
	if(event == LV_EVENT_PRESSED){
		selection_toggle_flag = 1;
	}
}

void encoder_selection()
{
	enc_value =  TIM2->CNT ;
	switch(encoder_select_sw)
	{
			case select_icons:
			{
				if(u8_once_occur_event_handler == 1)
				{
					u8_once_occur_event_handler = 0;
				lv_obj_set_event_cb(BPM_set, BPM_event_handler);
				lv_obj_set_event_cb(TEMP_set,TEMP_event_handler);
				lv_obj_set_event_cb(HUMIDITY_set,HUMIDITY_event_handler);
				}

				 if(enc_pressed() == 1)
				 {
						 selection_toggle_flag = !selection_toggle_flag;
						 u8_previous_data = 1;
				 }

				 if(TIM2->CNT > 64000  ){
				 		TIM2->CNT = 0 ;
				 	}

				 if(selection_toggle_flag == 1) {
					if ( u8_previous_data == 1 ) {
						u8_previous_data = 0 ;
								 TIM2->CNT = u8_select_icons  ;
							 }

					if(TIM2->CNT >= 6  ){
						TIM2->CNT = 6;
					}
					else if(TIM2->CNT <= 1  ){
						TIM2->CNT = 1;
					}
					u8_select_icons = TIM2->CNT ;
					
					u8_select_bpm = 0, u8_select_temp = 0, u8_select_humidity = 0, u8_select_spo2 = 0, u8_select_sw1 = 0, u8_select_sw2 = 0;
					
					if(u8_select_icons == 1){
						if(u8_once_occur_bpm == 0)
						{
							BPM_selected();
							u8_once_occur_bpm = 1, u8_once_occur_temp = 0, u8_once_occur_humidity = 0, u8_once_occur_spo2 = 0, u8_once_occur_sw1 = 0, u8_once_occur_sw2 = 0;
						}
					}
					else if(u8_select_icons == 2){
						if(u8_once_occur_temp == 0)
						{
							TEMP_selected();
							u8_once_occur_bpm = 0, u8_once_occur_temp = 1, u8_once_occur_humidity = 0, u8_once_occur_spo2 = 0, u8_once_occur_sw1 = 0, u8_once_occur_sw2 = 0;
						}
					}
				else if(u8_select_icons == 3){
						if(u8_once_occur_humidity == 0)
						{
							HUMIDITY_selected();
							u8_once_occur_bpm = 0, u8_once_occur_temp = 0, u8_once_occur_humidity = 1, u8_once_occur_spo2 = 0, u8_once_occur_sw1 = 0, u8_once_occur_sw2 = 0;
						}
					}
					else if(u8_select_icons == 5){
						if(u8_once_occur_spo2 == 0)
						{
							SW1_selected();
							u8_once_occur_bpm = 0, u8_once_occur_temp = 0, u8_once_occur_humidity = 0, u8_once_occur_spo2 = 1, u8_once_occur_sw1 = 0, u8_once_occur_sw2 = 0;
						}
					}
					else if(u8_select_icons == 6){
						if(u8_once_occur_sw1 == 0)
						{
							SW2_selected();
							u8_once_occur_bpm = 0, u8_once_occur_temp = 0, u8_once_occur_humidity = 0, u8_once_occur_spo2 = 0, u8_once_occur_sw1 = 1, u8_once_occur_sw2 = 0;
						}
					}
					else if(u8_select_icons == 4){
						if(u8_once_occur_sw2 == 0)
						{
							bpm_selected();
							u8_once_occur_bpm = 0, u8_once_occur_temp = 0, u8_once_occur_humidity = 0, u8_once_occur_spo2 = 0, u8_once_occur_sw1 = 0, u8_once_occur_sw2 = 1;
						}
					}

				 }
			 else if(selection_toggle_flag == 0){
					 u8_once_occur_bpm = 0, u8_once_occur_temp = 0, u8_once_occur_humidity = 0, u8_once_occur_spo2 = 0, u8_once_occur_sw1 = 0, u8_once_occur_sw2 = 0;
					 if(u8_select_icons == 1) {
						 BPM_change_fun();
					 }
					 else if(u8_select_icons == 2 ) {
						 TEMP_change_fun();
					 }
					else if(u8_select_icons == 3 ){
						 HUMIDITY_change_fun();
					 	 }
					 else if(u8_select_icons == 4 ) {
						 SPO2_change_fun();
					 }
					 else if(u8_select_icons == 5 ){
						 gas_change_fun();
					 }
					 else if(u8_select_icons == 6 ){
						 fio2_change_fun();
					 }					 
				 }

				encoder_select_sw = select_icons;
				break;
			}
	}
}

void vent_task_cb( void)
{
	//not use because it's create some delay
}

void vent_task(void)
{

}

