/*
 * ar_ventmodel.h
 *
 *  Created on: Nov 6, 2020
 *      Author: venka
 */

#ifndef EV600A_VENTILATOR_AR_VENTMODEL_H_
#define EV600A_VENTILATOR_AR_VENTMODEL_H_

typedef struct AR_VentModel {
    uint32_t vt;
    uint16_t fio2;
    uint16_t rrate;
    uint16_t peep;
    uint16_t ppeak;
    uint32_t mVolume;
    uint16_t flow;
    uint16_t trigger;
    uint8_t  mode;
    uint8_t  mode_2;
} AR_VentModel;

extern AR_VentModel vModel;
extern AR_VentModel vModelBase;
extern void vent_task(void);
void service_task();
void valve_calib_task();
void sensor_calib_task();
void leak_compliance_task();
void encoder_selection();
int  fio2_sw_toogle,gas_sw_toggle,insp_hold_sw_toogle,fgc_sw_toggle;
float select_bar, vt_bar_set, rr_bar_set, pip_bar_set, peep_bar_set, trigger_bar_set;
void switch_event();
void menu_task();
void fio2_calib_task();
void vent_task_1(void);
void vent_task_2(void);
void vent_task_cb_1( void);
void vent_task_cb_2( void);
//main screen
uint8_t u8_fio2_set_silder;
uint8_t   u8_TEMP_data , u8_ie_data, u8_ie_msb,u8_ie_lsb,u8_pip_data,u8_peep_data , u8_mode_data,check_data;
uint16_t u16_BPM_data, u16_tv_high_alarm, u16_tv_low_alarm;
int i_trigger_data;
uint8_t   u8_select_icons , u8_previous_data, u8_select_icons_alarm , u8_previous_data_alarm, u8_fio2_select_previous;
float sf32_fio2_high_alarm,sf32_fio2_low_alarm,sf32_mv_high_alarm,sf32_mv_low_alarm,sf32_pip_high_alarm,sf32_pip_low_alarm, sf32_tv_high_alarm,sf32_tv_low_alarm;
uint8_t  u8_fio2_high_alarm,u8_fio2_low_alarm,u8_pip_high_alarm,u8_pip_low_alarm, u8_mv_high_alarm, u8_mv_low_alarm;
uint16_t u16_tv_high_alarm,u16_tv_low_alarm;

void BPM_selected();
void TMP_selected();
void HUMIDITY_selected();
void pr_selected();
void peep_selected();
void trigger_selected();
void mode_selected();
void fgc_selected();
void SW1_selected();
void SW2_selected();
void insp_hold_selected();

void btn_selection();
void BPM_change_fun();
void TEMP_change_fun();
void HUMIDITY_change_fun();
void SOP2_change_fun();
void trigger_change_fun();
void mode_change_fun();
void peep_change_fun();

void fgc_change_fun();
void gas_change_fun();
void fio2_change_fun();
void insp_hold_change_fun();
void btn_change_fun();


#endif /* LV_EXAMPLES_SRC_AR_VENTILATOR_AR_VENTMODEL_H_ */
