/*
 * ar_oxygen_monitor.h
 *
 *  Created on: Oct 20, 2020
 *      Author: venka
 */

#ifndef _AR_HIFLOW_H_
#define _AR_HIFLOW_H_

#include "../../../lvgl/lvgl.h"
#include "EV600A_common.h"
#include "EV600A_valdisplay.h"

 lv_obj_t *pchart; // pressure
lv_obj_t *pseries;
lv_obj_t *fchart;  // flow
lv_obj_t *fseries;
lv_obj_t *vchart; //volume
lv_obj_t *vseries;

extern lv_obj_t *FGC_on_off;
extern lv_obj_t *GAS_ON_OFF;
extern lv_obj_t *FIO2_ON_OFF;
extern lv_obj_t *INSP_HOLD_ON_OFF;
extern lv_obj_t *GAS_1_monitor_text;

lv_obj_t * ddlist_FIO2 ;
lv_obj_t * ddlist_GAS;

extern lv_obj_t * insp_in_ie;

extern lv_obj_t * modtxt ;
extern lv_obj_t *mode_data;
//bar
extern lv_obj_t *ie_bar;
extern lv_obj_t *vt_bar;
extern lv_obj_t *rr_bar;
extern lv_obj_t *pip_bar;
extern lv_obj_t *peep_bar;
extern lv_obj_t *trigger_bar;

lv_obj_t * line_graph;

// Display Values
extern lv_valdisplay TEMP_VAL;
extern lv_valdisplay HUMIDITY_VAL;
extern lv_valdisplay BPM_VAL;
extern lv_valdisplay SPO2_VAL;
extern lv_valdisplay ppeakval;
extern lv_valdisplay triggerval;
extern lv_valdisplay modeval;
extern lv_valdisplay modeval_2;

void mute_fun(int mute_data);
//set paramter
lv_obj_t * BPM_set;
lv_obj_t * TEMP_set;
 lv_obj_t * HUMIDITY_set ;
 lv_obj_t * SPO2_set;
 lv_obj_t * PEEP_set ;
 lv_obj_t * TRIGGER_set ;
 lv_obj_t * MODE_set ;
 lv_obj_t * mode_highlight_box;
 
 lv_obj_t * BPM_monitor_data;
 lv_obj_t * TEMP_monitor_data;
 lv_obj_t * HUMIDITY_monitor_data;
 lv_obj_t * SPO2_monitor_data ;
 lv_obj_t * Peep_monitor_data;
 lv_obj_t * trigger_monitor_data;
 lv_obj_t * mode_monitor_data;

 lv_obj_t * BPM_parameter_name;
 lv_obj_t * TEMP_parameter_name;
 lv_obj_t * HUMIDITY_parameter_name;
 lv_obj_t * SPO2_parameter_name;

 //sw
 lv_obj_t * SW1_sw;
 lv_obj_t *SW2_sw;
 lv_obj_t *INSP_HOLD_sw;
 lv_obj_t *FGC_sw;
 uint8_t u8_alarm_btn_toch_selection;
 lv_obj_t * alarmsBtn;


 int  fio2_sw_toogle,gas_sw_toggle,insp_hold_sw_toogle,fgc_sw_toggle;
 void clear_screen();
void ARIES_Monitor(void);
void ARIES_applybuttonstyles(lv_obj_t *btn);
void setGroupFocus(lv_group_t *grp);
void setHomeGroupFocus();

//static void mode_select_event_handler(lv_obj_t * obj, lv_event_t event);
#endif /* AR_OXYGEN_MONITOR_AR_OXYGEN_MONITOR_H_ */
