/*
 * ar_ventsettings.c
 *
 *  Created on: Nov 17, 2020
 *      Author: venka
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "EV600A_ventsettings.h"
#include "EV600A_common.h"

static lv_obj_t * kb;
static lv_obj_t * cont;



static void kb_event_cb(lv_obj_t * _kb, lv_event_t e)
{
    lv_keyboard_def_event_cb(kb, e);

    if(e == LV_EVENT_CANCEL) {
        if(kb) {
            //lv_obj_set_height(tv, LV_VER_RES);
            lv_obj_del(kb);
            kb = NULL;
        }
    }
}

static void ta_event_cb(lv_obj_t * ta, lv_event_t e)
{
    if(e == LV_EVENT_RELEASED) {
        if(kb == NULL) {
            //lv_obj_set_height(tv, LV_VER_RES / 2);
            kb = lv_keyboard_create(lv_scr_act(), NULL);
            lv_obj_set_event_cb(kb, kb_event_cb);

            lv_indev_wait_release(lv_indev_get_act());
        }
//        lv_textarea_set_cursor_hidden(ta, false);
//        lv_keyboard_set_textarea(kb, ta);
    } else if(e == LV_EVENT_DEFOCUSED) {
//        lv_textarea_set_cursor_hidden(ta, true);
    }
}

static void cloud_close_event_cb(lv_obj_t * obj, lv_event_t event)
{
    if(event == LV_EVENT_CLICKED) {
    	lv_obj_set_hidden(cont, true);
    }
}

lv_obj_t * lv_create_ventcloud()
{
    cont = lv_cont_create(lv_scr_act(), NULL);
    lv_obj_set_pos(cont, 400, 50 );
    lv_obj_set_size(cont, 450, 450);
    lv_obj_set_style_local_bg_color(cont, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT,
           ARIES_HF_BLUE);
	lv_obj_set_style_local_text_color(cont, LV_LABEL_PART_MAIN, LV_STATE_DEFAULT, LV_COLOR_WHITE);
    lv_obj_t * ta = lv_textarea_create(cont, NULL);

    lv_obj_t *ssidlbl = lv_label_create(cont, NULL);
    lv_obj_set_pos(ssidlbl, 50, 50 );
	lv_label_set_text(ssidlbl,"SSID:");

    lv_textarea_set_text(ta, "");

    lv_textarea_set_placeholder_text(ta, "SSID");
    lv_textarea_set_one_line(ta, true);
    lv_textarea_set_cursor_hidden(ta, true);
    lv_obj_set_event_cb(ta, ta_event_cb);
    lv_obj_set_pos(ta, 100, 50 );

    lv_obj_t *passlbl = lv_label_create(cont, NULL);
    lv_obj_set_pos(passlbl,50, 100 );
	lv_label_set_text(passlbl,"Password:");

    lv_obj_t * pass = lv_textarea_create(cont, ta);
    lv_textarea_set_pwd_mode(pass, true);
    lv_obj_set_pos(pass, 100, 100 );

    lv_textarea_set_placeholder_text(pass, "Password");

	kb = lv_keyboard_create(cont,NULL);
	lv_keyboard_set_textarea(kb,pass);
    lv_obj_set_style_local_bg_color(kb, LV_KEYBOARD_PART_BG, LV_STATE_DEFAULT,
    		ARIES_HF_LIGHT_GRAY);
    lv_obj_set_style_local_bg_color(kb, LV_KEYBOARD_PART_BTN, LV_STATE_DEFAULT,
    		ARIES_HF_BLUE);
	lv_obj_set_style_local_text_color(kb, LV_KEYBOARD_PART_BTN, LV_STATE_DEFAULT, LV_COLOR_WHITE);
	lv_obj_set_y(kb,150);

	lv_obj_t *cloudCloseBtn = lv_btn_create(cont, NULL);
    lv_obj_set_pos(cloudCloseBtn, 200, 380 );
    lv_obj_set_size(cloudCloseBtn, 100, 50);
    lv_obj_set_style_local_value_str(cloudCloseBtn, LV_OBJ_PART_MAIN, LV_STATE_DEFAULT, LV_SYMBOL_HOME "Back");
    ARIES_applybuttonstyles(cloudCloseBtn);

    lv_obj_set_event_cb(cloudCloseBtn, cloud_close_event_cb);
	lv_obj_set_hidden(cont, true);
	//json_dump();
	return cont;

}
